#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc, char **argv) {
  int nlambdas = 21;
  int i, j, k, t, oldt;
  int nsamples, isauto;
  FILE *fp;
  double c1;
  double dgdl, sauto, ssauto, errs, denom, meandelta, sd;
  double dg, myse;
  double dgdls;
  double ses;
  double* deltas;
  deltas = (double*)malloc(100000000 * sizeof(double));
  char ch;

  fp = fopen(argv[1], "r");
  if (fp == NULL) {
    printf("%s missing\n", argv[1]);
    exit(EXIT_FAILURE);
  }

  nsamples = 0;
  dgdl = 0.0;
  for(j=0;j<100000000;j++) deltas[j] = 0.0;
  while (fscanf(fp, "%lf", &c1) == 1) {
    dgdl += c1;
    deltas[nsamples] = c1;
    nsamples++;
  }
  dgdl /= (double)nsamples;

  denom = 0.0;
  for(j=0;j<nsamples;j++) {
    deltas[j] -= dgdl;
    denom += deltas[j]*deltas[j]/((double)nsamples);
  }

  ssauto = 0.0;
  for(k=1;k<nsamples-1;k++) {
    sauto=0.0;
    for(j=1;j<nsamples-k;j++) {
      sauto += deltas[j]*deltas[j+k]/((double)nsamples-(double)k);
    }
    if(sauto <= 0.0 && k>3) break;
    ssauto += 2.0*sauto*(1.0-(double)k/(double)nsamples);
  }
  ssauto /= denom;
  ssauto += 1.0;

  dgdls = 0.0;
  errs = 0.0;
  isauto = (int)ssauto;
  j = 0;
  oldt = 0;
  while((int)round((double)j*ssauto) < nsamples) {
    t = (int)round((double)j*ssauto);
    if(j==0 || t!=oldt) {
      dgdls += deltas[t]+dgdl;
      errs += deltas[t]*deltas[t];
      oldt = t;
      j++;
    }
  }
  dgdls /= (double)j;
  sd = sqrt(errs/((double)(j-1)));
  ses = sd*sqrt(1.0+2.0*ssauto)/sqrt((double)k);
  ses = sd/sqrt((double)j);

  printf(" %s", argv[1]);
  printf(" dvdl %lf", dgdls);
  printf(" sauto %lf", ssauto);
  printf(" N_unc %i", j);
  printf(" sd %lf", sd);
  printf(" se %lf\n", ses);
  return 0;
}

