#!/usr/bin/python

import math, numpy

nwalkers = 48

data1 = []
for i in range(nwalkers):
  #print i
  ifilename = "../COLVAR."+str(i)
  ifile = open(ifilename, "r").readlines()
  walker = []
  for line in ifile:
    if line[0]!="#":
      sline = str.split(line)
      #if ((float(sline[0]) > 100.0)): # and (float(sline[0]) < 9000.1)):
      walker.append([float(sline[1]), float(sline[2])])
  data1.append(walker)

skip = 1000
data1 = numpy.array(data1)
angles = data1[:,skip:,0]
biases = data1[:,skip:,1]
angles[angles< -math.pi/2.0] = angles[angles< -math.pi/2.0] + 2.0*math.pi
averages = numpy.mean(angles, axis=1)
order = numpy.argsort(averages)
orderedbiases = []
orderedangles = []
for i in range(nwalkers):
  orderedbiases = numpy.append(orderedbiases, biases[order[i],:])
  orderedangles = numpy.append(orderedangles, angles[order[i],:])

data2 = []
for i in range(nwalkers):
  #print i
  ifilename = "../dhdl"+str(i)+".xvg"
  ifile = open(ifilename, "r").readlines()
  walker = []
  for line in ifile:
    if line[0]!="#" and line[0]!="@":
      sline = str.split(line)
      walker.append(float(sline[2])+float(sline[3])+float(sline[4]))
  data2.append(walker)

data2 = numpy.array(data2)
data2 = data2 - numpy.mean(data2)
dhdl = data2[:,skip:]
ordereddhdl = []
for i in range(nwalkers):
  ordereddhdl = numpy.append(ordereddhdl, dhdl[order[i],:])

weights = numpy.exp(orderedbiases/0.298/8.314)
reweighted = ordereddhdl*weights
reweighted = reweighted/numpy.mean(weights)

ofile = open("reweighted.txt", "w")
for i in range(int(len(reweighted)/10.0)):
  #ofile.write("%f %f %f\n" % (ordereddhdl[i*10], weights[i*10], reweighted[i*10]))
  ofile.write("%f\n" % reweighted[i*10])
ofile.close()

weights2 = numpy.exp(orderedbiases[orderedangles<math.pi/2.0]/0.298/8.314)
reweighted2 = ordereddhdl[orderedangles<math.pi/2.0]*weights2
reweighted2 = reweighted2/numpy.mean(weights2)

ofile = open("reweightedcis.txt", "w")
for i in range(int(len(reweighted2)/10.0)):
  ofile.write("%f\n" % reweighted2[i*10])
ofile.close()

weights3 = numpy.exp(orderedbiases[orderedangles>math.pi/2.0]/0.298/8.314)
reweighted3 = ordereddhdl[orderedangles>math.pi/2.0]*weights3
reweighted3 = reweighted3/numpy.mean(weights3)

ofile = open("reweightedtrans.txt", "w")
for i in range(int(len(reweighted3)/10.0)):
  ofile.write("%f\n" % reweighted3[i*10])
ofile.close()

